'****************************************************************************
'*  axppi02w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Axppi02w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    Public Const MAX_SOCKETS As Integer = 16
    Public Const SOCKET_AUTO As Short = &HFFFFS

    Public Const PORT_A As Integer = 0
    Public Const PORT_B As Integer = 1
    Public Const PORT_C As Integer = 2
    Public Const PORT_CMD As Integer = 3

    ' G[R[h
    Public Const SUCCESS As Integer = 0                 ' ُȂiIj
    Public Const ERR_SYSTEM As Integer = 1              ' Windows  GetLastError() R[Ă
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCX܂
    Public Const ERR_IN_USE As Integer = 3              ' w̃foCX͎gpł
    Public Const ERR_INVALID_SOCKET As Integer = 4      ' Ș_\Pbgł
    Public Const ERR_RESOURCE As Integer = 5            ' \[XG[
    Public Const ERR_INVALID_PORT As Integer = 6        ' sȃ|[gv
    Public Const ERR_INVALID_ARGUMENT As Integer = 7    ' sȈv܂
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[

    ' bZ[W
    Public Const WM_OFS_CARD_REMOVAL As Integer = 0
    Public Const WM_OFS_IN As Integer = 1

    ' \[X
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1    ' MAX_MEM_REGISTERS
    Public Const MAX_IO As Integer = 20 - 1    ' MAX_IO_PORTS
    Public Const MAX_IRQ As Integer = 7 - 1    ' MAX_IRQS
    Public Const MAX_DMA As Integer = 7 - 1    ' MAX_DMA_CHANNELS
    Public Const MAX_RSV As Integer = 3 - 1

    'I/O\[X
    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    ' API
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer, ByRef pvInitArg As Integer) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02Close(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02GetResource(ByVal wLogSocket As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02InPort(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByRef pbInValue As Byte) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02OutPort(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02SetDirection(ByVal wLogSocket As Short, ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("axppi02.dll")> _
    Public Shared Function Pi02GetLastError(ByVal wLogSocket As Short) As Integer
    End Function

    '*****************************************************************************
    '*    AXP-PI02 DLL,Driver̃o[Wԍ擾                            *
    '*    pdwDllVer DLLo[Wԍi[                                  *
    '*        pdwDrvVer Drivero[Wԍi[                               *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
        Try
            GetVersion = Pi02GetVersion(pdwDllVer, pdwDrvVer)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-PI02̔Cӂ̃foCX̎gp錾                               *
    '*    pwLogSocket gpfoCXi[AhX                     *
    '*        hWnd        bZ[W𑗂EBhEnh                     *
    '*        uWMBase     ƂȂ郁bZ[WID                                 *
    '*        pvInitArg   gp(0Zbg)                                      *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer, ByRef pvInitArg As Integer) As Boolean
        Try
            Create = Pi02Create(pwLogSocket, hWnd, uWMBase, pvInitArg)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-PI02̔Cӂ̃foCX̎gpJ                               *
    '*    wLogSocket gpfoCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Close(ByVal wLogSlocket As Short) As Boolean
        Try
            Close = Pi02Close(wLogSlocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function

    '*****************************************************************************
    '*    wfoCX̃\[X擾                                   *
    '*    wLogSlocket ׂfoCX                                         *
    '*        pres        \[Xi[\                           *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetResource(ByVal wLogSlocket As Short, ByRef pres As Resource) As Boolean
        Try
            GetResource = Pi02GetResource(wLogSlocket, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function

    '*****************************************************************************
    '*    |[g``bɑ΂PoCg                                     *
    '*    wLogSlocket   ͂foCX                                     *
    '*        dwPort        |[gԍ                                           *
    '*        pbValue       ̓f[^i[AhX                         *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function InPort(ByVal wLogSlocket As Short, ByVal dwPort As Integer, ByRef pbValue As Byte) As Boolean
        Try
            InPort = Pi02InPort(wLogSlocket, dwPort, pbValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function

    '*****************************************************************************
    '*    |[g``bA܂̓R}h|[gւPoCgo                   *
    '*    wLogSlocket  o͂foCX                                      *
    '*        dwPort       |[gԍ                                            *
    '*        bValue       o͂f[^                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function OutPort(ByVal wLogSlocket As Short, ByVal dwPort As Integer, ByVal bValue As Byte) As Boolean
        Try
            OutPort = Pi02OutPort(wLogSlocket, dwPort, bValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function

    '*****************************************************************************
    '*    fBNV|[gɏo                                         *
    '*    wLogSlocket   o͂foCX                                     *
    '*        bDirectionBit fBNVrbg                                 *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function SetDirection(ByVal wLogSlocket As Short, ByVal bDirectionBit As Byte) As Boolean
        Try
            SetDirection = Pi02SetDirection(wLogSlocket, bDirectionBit)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetDirection = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-PI02̃G[R[h                                             *
    '*    wLogSlocket  G[foCX                              *
    '* ߂l G[R[h                                                       *
    '*****************************************************************************
    Public Function GetLastError(ByVal wLogSocket As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Pi02GetLastError(wLogSocket)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-PI02 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
